Property (Apache FOP Core 2.11 API)
Date: 2025-04-24

org.apache.fop.fo.properties

## Class Property

- java.lang.Object
- - org.apache.fop.fo.properties.Property

- Direct Known Subclasses:
    CharacterProperty, ColorProperty, CondLengthProperty, EnumNumber, EnumProperty, KeepProperty, LengthPairProperty, LengthProperty, LengthRangeProperty, ListProperty, NCnameProperty, NumberProperty, NumericProperty, OptionalCharacterProperty, RelativeNumericProperty, StringProperty, ToBeImplementedProperty, URIProperty

      public abstract class Property
      extends Object

  Base class for all property objects

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static org.apache.commons.logging.Log` | `log` Logger for all property classes

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Property()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `char` | `getCharacter()` This method expects to be overridden by subclasses
    `Color` | `getColor(FOUserAgent foUserAgent)` This method expects to be overridden by subclasses
    `CondLengthProperty` | `getCondLength()` This method expects to be overridden by subclasses
    `int` | `getEnum()` This method expects to be overridden by subclasses
    `KeepProperty` | `getKeep()` This method expects to be overridden by subclasses
    `Length` | `getLength()` This method expects to be overridden by subclasses
    `LengthPairProperty` | `getLengthPair()` This method expects to be overridden by subclasses
    `LengthRangeProperty` | `getLengthRange()` This method expects to be overridden by subclasses
    `List` | `getList()` This method expects to be overridden by subclasses
    `String` | `getNCname()` This method expects to be overridden by subclasses
    `Number` | `getNumber()` This method expects to be overridden by subclasses
    `Numeric` | `getNumeric()` This method expects to be overridden by subclasses
    `Object` | `getObject()` This method expects to be overridden by subclasses
    `SpaceProperty` | `getSpace()` This method expects to be overridden by subclasses
    `String` | `getSpecifiedValue()` Return the original value specified for the property attribute.
    `String` | `getString()` This method expects to be overridden by subclasses.
    `boolean` | `isAuto()`
    `void` | `setSpecifiedValue(String value)` Set the original value specified for the property attribute.
    `String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### log

          protected static final org.apache.commons.logging.Log log

      Logger for all property classes

  - ### Constructor Detail

    - #### Property

          public Property()

  - ### Method Detail

    - #### setSpecifiedValue

          public void setSpecifiedValue(String value)

      Set the original value specified for the property attribute.
      Parameters:
        `value` - The specified value.

    - #### getSpecifiedValue

          public String getSpecifiedValue()

      Return the original value specified for the property attribute.
      Returns:
        The specified value as a String.

    - #### getLength

          public Length getLength()

      This method expects to be overridden by subclasses
      Returns:
        Length property value

    - #### getColor

          public Color getColor(FOUserAgent foUserAgent)

      This method expects to be overridden by subclasses
      Parameters:
        `foUserAgent` - FOP user agent
      Returns:
        ColorType property value

    - #### getCondLength

          public CondLengthProperty getCondLength()

      This method expects to be overridden by subclasses
      Returns:
        CondLength property value

    - #### getLengthRange

          public LengthRangeProperty getLengthRange()

      This method expects to be overridden by subclasses
      Returns:
        LenghtRange property value

    - #### getLengthPair

          public LengthPairProperty getLengthPair()

      This method expects to be overridden by subclasses
      Returns:
        LengthPair property value

    - #### getSpace

          public SpaceProperty getSpace()

      This method expects to be overridden by subclasses
      Returns:
        Space property value

    - #### getKeep

          public KeepProperty getKeep()

      This method expects to be overridden by subclasses
      Returns:
        Keep property value

    - #### getEnum

          public int getEnum()

      This method expects to be overridden by subclasses
      Returns:
        integer equivalent of enumerated property value

    - #### isAuto

          public boolean isAuto()

      Returns:
        true if the property is an enum and has value 'auto'

    - #### getCharacter

          public char getCharacter()

      This method expects to be overridden by subclasses
      Returns:
        char property value

    - #### getList

          public List getList()

      This method expects to be overridden by subclasses
      Returns:
        collection of other property (sub-property) objects

    - #### getNumber

          public Number getNumber()

      This method expects to be overridden by subclasses
      Returns:
        Number property value

    - #### getNumeric

          public Numeric getNumeric()

      This method expects to be overridden by subclasses
      Returns:
        Numeric property value

    - #### getNCname

          public String getNCname()

      This method expects to be overridden by subclasses
      Returns:
        NCname property value

    - #### getObject

          public Object getObject()

      This method expects to be overridden by subclasses
      Returns:
        Object property value

    - #### getString

          public String getString()

      This method expects to be overridden by subclasses.
      Returns:
        String property value

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

Copyright © 2025 Apache Software Foundation. All rights reserved.